#include "tank.h"
#include "simulation.h"
#include "movement.h"
#include "driving.h"

/* Versucht herauszufinden, ob es schneller ist, sich zuerst zu drehen und dann vorwärts, anstatt nur rückwärts zu fahren */
void drive(tank *t, point *p) {
    int i, j;
    float r;
    point q;
    tank *dummy;
    dummy = tank_create(p);
    tank_copy(t, dummy, true, false);

    SDL_FillRect(route, NULL, SDL_MapRGB(route->format, 0, 0, 0));
    i = 0;
    tank_movement_move(dummy, p);
    while(dummy->moves) {
        tank_loop(dummy);
        pixelColor(route, dummy->x, dummy->y, 0x0000FFFF);
        i++;
    }


    tank_copy(t, dummy, true, false);

    q.x = (p->x-dummy->x)*cos(dummy->r) + (p->y-dummy->y)*sin(dummy->r);
    q.y = -(p->x-dummy->x)*sin(dummy->r) + (p->y-dummy->y)*cos(dummy->r);
    //r = rotation_cosmetic((dummy->y < p->y ? 1 : -1)*atan(q.y/q.x) + dummy->r);
    //r = rotation_cosmetic((dummy->x > p->x ? -M_PI_2 : M_PI_2)+(dummy->y > p->y ? 1 : -1)*atan(differ(p->x, dummy->x)/differ(p->y, dummy->y)));
    /* In den richtigen Quadranten setzen */
    /* p->y < dummy->y = oben
     * p->x < dummy->x = links
     */
    while(dummy->moves) {
        pixelColor(route, dummy->x, dummy->y, 0x00FFFFFF);
        tank_loop(dummy);
        j++;
    }

    r = rotation_cosmetic(atan(differ(p->y, dummy->y)/differ(p->x, dummy->x)));
    if(p->y < dummy->y && p->x < dummy->x) {
        r = r + M_PI;
    }
    if(p->y < dummy->y && !(p->x < dummy->x)) {
        r = -r;
    }
    if(!(p->y < dummy->y) && p->x < dummy->x) {
        r = -r - M_PI;
    }
    r = rotation_cosmetic(r);

    j = 0;
    tank_movement_rotate(dummy, r);
    tank_movement_move(dummy, p);
    while(dummy->moves) {
        pixelColor(route, dummy->x, dummy->y, 0x00FFFFFF);
        tank_loop(dummy);
        j++;
    }
    printf("%d:%d\n", i, j);
    if(i > j) {
        tank_movement_rotate(t, r);
    }
    tank_movement_move(t, p);
}

inline int int_power(int x, int y) {
    int i, n;
    n = 1;
    for(i = 0;i < y;i ++) {
        n*=x;
    }
    return n;
}

void tank_waypoint_fill_movements(waypoint *waypoints, tank *t, int i) {
    int j;
    float r;
    waypoint *way;
    point pos;
    way = waypoints;
    pos.x = t->x;
    pos.y = t->y;
    for(j = 0;way ;j ++) {
        if ((i & (0x01 << j)) == 0) {
            r = rotation_cosmetic(atan(differ(way->position.y, pos.y)/differ(way->position.x, pos.x)));
            if(way->position.y < pos.y && way->position.x < pos.x) {
                r = r + M_PI;
            }
            if(way->position.y < pos.y && !(way->position.x < pos.x)) {
                r = -r;
            }
            if(!(way->position.y < pos.y) && way->position.x < pos.x) {
                r = -r - M_PI;
            }
            r = rotation_cosmetic(r);
            tank_movement_rotate(t, r);
        }
        tank_movement_move(t, &way->position);

        pos.x = way->position.x;
        pos.y = way->position.y;
        way = way->next;
    }
}

void tank_waypoint_recalc_movements(tank *t) {
    int n, i;
    waypoint *cur;
    tank **dummies;
    float *dummies_time;
    int dummies_count;
    point p;

    float best_time;
    int best_index;

    i = 0;
    cur = t->waypoints;
    for(n = 0; cur; n++) {
        cur = cur->next;
    }

    tank_movement_clear(t);
    if(n == 0)
        return;

    dummies_count = int_power(2, n);
    dummies =(tank**) malloc(dummies_count*sizeof(tank*));
    dummies_time =(float*) malloc(dummies_count*sizeof(float));
    for(i = 0;i < dummies_count;i++) {
        p.x = t->x;
        p.y = t->y;
        dummies[i] = tank_create(&p);
        tank_copy(t, dummies[i], false, false);

        tank_waypoint_fill_movements(t->waypoints, dummies[i], i);

        /* calculate time */
        dummies_time[i] = tank_movement_chronometry(dummies[i], true);
        if(i == 0) {
            best_time = dummies_time[i];
            best_index = i;
        }

        if(dummies_time[i] < best_time) {
            best_time = dummies_time[i];
            best_index = i;
        }
    }
    tank_waypoint_fill_movements(t->waypoints, t, best_index);

    for(i = 0;i < dummies_count;i++) {
        tank_destroy(dummies[i]);
    }
    free(dummies);
}


void tank_waypoint_copy(const tank *orig, tank *copy) {
    waypoint *ptr = NULL;
    if(orig->waypoints) {
        ptr = orig->waypoints;
        while(ptr) {
            tank_waypoint_add(copy, &ptr->position);
            ptr = ptr->next;
        }
    }
}

void tank_waypoint_add(tank *t, point *p) {
    waypoint *item=NULL, *cur=NULL;

    item =(waypoint*) malloc(sizeof(waypoint));

    if(t->waypoints) {
        cur = t->waypoints;
        while(cur) {
            if(cur->next == NULL)
                break;
            cur = cur->next;
        }

        cur->next = item;
    } else {
        t->waypoints = item;
    }
    item->next = NULL;
    item->position.x = p->x;
    item->position.y = p->y;
    return;
}

void tank_waypoint_drop(tank *t) {
    waypoint *unqeued;

    if(t->waypoints == NULL)
        return;

    unqeued = t->waypoints;
    t->waypoints = t->waypoints->next;

    free(unqeued);
    return;
}

void tank_waypoint_clear(tank *t) {
    waypoint *cur = NULL, *next=NULL;
    cur = t->waypoints;
    t->waypoints = NULL;
    while(cur) {
        next = cur->next;
        free(cur);
        cur = next;
    }
}
