#ifndef tank_h
#define tank_h

#include <stdbool.h>
#include <math.h>

#include "main.h"


#define differ(a, b) (a > b ? a - b : b - a)

typedef struct _point {
    float x, y;
} vector, point;

enum MOVEMENT_TYPE {
    MT_MOVE,
    MT_ROTATE
};

struct _movement;
typedef struct _movement movement;

struct _tank;
typedef struct _tank tank;

struct _waypoint;
typedef struct _waypoint waypoint;

struct _waypoint {
    waypoint *next;
    point position;
};

struct _movement {
    movement *next;
    enum MOVEMENT_TYPE type;
    point target;
    float r;
};

struct _tank {
    float x, y;
    float r;
    float a, b;

    movement *moves;
    bool idle;

    waypoint *waypoints;

    bool hasolddata;
    float a1, a2, b1, b2, u1, u2, v1, v2;
    float velo1, velo2;
};

/* other tools
 */
float rotation_cosmetic(float r);

#endif
